unit Client;

interface
uses Error;

//  -

type TClient = class( TObject )
 private
   m: Double; //   -  
   sigma: Double; //    -  
   data: Double; //    

 public
   constructor Create(initStatus: Integer);
   function PlayData: Double;
   function GetSigma: Double;

 public
   status: Integer; // : 0- , 1-  , 2 -    
   error: TError; //       
   workTime: Double; //   
   errorTime: Double; //   
   waitTime: Double; //   

 private


end;

type PTClient = ^TClient;

implementation
uses Sysutils, Math;

constructor TClient.Create(initStatus: Integer);
begin
  inherited Create;  // Initialize inherited parts
  m := Random;
  sigma := (1 - m)*Random / 3 ;
  status := initStatus;
  workTime := 0;
  errorTime := 0;
  waitTime := 0;
end;

// -         m  sigma
//    
function TClient.PlayData: Double;
begin
  data := RandG(m, sigma);
  result := data;
end;


//  sigma
function TClient.GetSigma: Double;
begin
  result := sigma;
end;

end.
