unit MonteCarloPK;

interface
uses classes, contnrs, TeEngine, Error, wndPlayResults;
//  
type TMonteCarloPK = class( TObject )
 private
  clientsNum: Integer; // -
  programmersNum: Integer; //- 
  a: Double; //        
  errorsNum0: Integer; //     
  coeffComplexity: Double; //      
  Yk: Double; //     (1/)
  Mu: Double; //    (1/)
  dT: Double; //  ()

  P_newErr: Double; //      
  Y_newErr: Double; //       
  isP_newErr: Boolean; //      ,   



  clientList: TObjectList; // -

  serverStatus: Integer; // : 0 - , 1 -  
  waitTime: Double; //   
  error: TError; //         

  errorClientList: TObjectList; //  
  errorServerList: TObjectList; //  
  busyProgrammersNum: Integer; //  

  playNum: Integer; //       
  workClientNum: Integer;   //   

  errorIntensity: Double; //      
  Ter: Double; //      ();
  averTer: Double; //      ();
  Per: Double; //     

  //   
//  clientErrorsNumByDt: Integer; // -      dT
  clientCorrectNumByDt: Integer; // -     dT
  clientNewErrorAdd: Integer; // -        
  serverNewErrorAdd: Integer; // -        
  isUpdate: Boolean; //          
  curTer: Double; //      
  programInRepairTime: Double; //      


 public
  M: Integer; //  
  K: Integer; // 


 public
   function InitializeByFormSettings: boolean;
   function SearchFirstErrorsNum( p: Double; y0: Double; t: Double) : Integer;
   function P( y, t: Double; k: Integer) : Double;

   function PlayAllStep( callThread: TThread ): TfmPlayResults;
   function PlayAllPlay: Integer;
   function MultySeriesVal(toSer: TChartSeries; multy: Double): Integer;

 private
   function BeginPlay: Integer;
   procedure PlayIteration;
   function PlayEvent(p: Double): Boolean;
   function GetPlayNum: Integer;
   function GetBeginSettingsStr: String;
   function CallKoeff( a: Double; E: Integer) : Double;
   function CorrectError( err: TError ): Integer;
   function PlayErrorInsert( errLst: TObjectList): Integer ;
   function GetErrorID( errLst: TObjectList; data, delta: Double): TError;
   function AddSeriesVal(fromSer, toSer: TChartSeries): Integer;


end;

var
  mkPK: TMonteCarloPK;


implementation
uses Sysutils, Dialogs, Forms, FormSettings, Client, wndAllPlayResults ;






//  K 
//   
function TMonteCarloPK.PlayAllPlay: Integer;
var
 curWndResult: TfmPlayResults;
 resultsList: TObjectList;
 i: Integer;
 wndAllResults: TAllPlayResults;
 wndPlayRes: TfmPlayResults;
 avClientErrNums, avWorkClientNum, avServerErrNums,
 avNewClientErrorAdd, avNewServerErrorAdd: Integer;
 avAverCorrectTime, avAverWaitTime, avCorrectServerTime: Double;
 avPer, avTer, avAverTer: Double;
 avKg: Double;
// averSeriesList: Array[0..3] As TObjectList;
  beginSettingsStr: String;
begin
  result := 0;
  resultsList :=  TObjectList.Create;

//  for i:=0 to 3 do averSeriesList[i] := TObjectList.Creat;

  for i:=0 to (K-1) do begin
    isUpdate := False;
    curWndResult := PlayAllStep( nil );
    resultsList.Add(curWndResult);

    Inc(result);

  end; //for i:=0 to (K-1) do begin

//       
  wndPlayRes := TfmPlayResults.Create(Application);
  wndPlayRes.Caption := '    ';
  beginSettingsStr := GetBeginSettingsStr + ';  :' + IntToStr(K);
  wndPlayRes.meBeginSettings.Lines.Add( beginSettingsStr );

//       
  wndAllResults := TAllPlayResults.Create(Application);
  wndAllResults.Caption := '   ' +  IntToStr(K) + ' ';
  wndAllResults.m_resultsList := resultsList;
  wndAllResults.m_allTime := M*dT;
  wndAllResults.edCurTime.Text := FloatToStr( (M*dT)/2) ;

  avClientErrNums := 0; avWorkClientNum := 0; avAverCorrectTime:=0; avAverWaitTime:=0;
  avServerErrNums := 0; avCorrectServerTime := 0; avNewClientErrorAdd := 0;
  avNewServerErrorAdd := 0;  avPer:=0; avTer := 0; avAverTer := 0;
  avKg := 0;
  for i:=0 to (resultsList.Count - 1) do begin
     curWndResult := resultsList.Items[i] As TfmPlayResults;
    //  
    avClientErrNums := avClientErrNums +  StrToInt(curWndResult.edClientErrNums.Text);
    avWorkClientNum := avWorkClientNum +  StrToInt(curWndResult.edWorkClientNum.Text);
    avAverCorrectTime := avAverCorrectTime +  StrToFloat(curWndResult.edAverCorrectTime.Text);
    avAverWaitTime := avAverWaitTime +  StrToFloat(curWndResult.edAverWaitTime.Text);
    avServerErrNums := avServerErrNums +  StrToInt(curWndResult.edServerErrNums.Text);
    avCorrectServerTime := avCorrectServerTime +  StrToFloat(curWndResult.edCorrectServerTime.Text);
    avNewClientErrorAdd := avNewClientErrorAdd +  StrToInt(curWndResult.edNewClientErrorAdd.Text);
    avNewServerErrorAdd := avNewServerErrorAdd +  StrToInt(curWndResult.edNewServerErrorAdd.Text);

    avPer := avPer +  StrToFloat(curWndResult.edPer.Text);
    avTer := avTer +  StrToFloat(curWndResult.edTer.Text);
    avAverTer := avAverTer +  StrToFloat(curWndResult.edAverTer.Text);
    avKg := avKg +  StrToFloat(curWndResult.edKg.Text);

    AddSeriesVal(curWndResult.chNums.Series[0], wndPlayRes.chNums.Series[0]);
    AddSeriesVal(curWndResult.chClientErrors.Series[0], wndPlayRes.chClientErrors.Series[0]);
    AddSeriesVal(curWndResult.chErrorsGist.Series[0], wndPlayRes.chErrorsGist.Series[0]);
//    AddSeriesVal(curWndResult.chServerErrors.Series[0], wndPlayRes.chServerErrors.Series[0]);
    AddSeriesVal(curWndResult.chAvTer.Series[0], wndPlayRes.chAvTer.Series[0]);
    AddSeriesVal(curWndResult.chErrorsIntensity.Series[0], wndPlayRes.chErrorsIntensity.Series[0]);

  end; //for i:=0 to (resultsList.Count - 1) do begin

  with wndPlayRes do begin
    edClientErrNums.Text :=IntToStr(Round(avClientErrNums/K));
    edWorkClientNum.Text :=IntToStr(Round(avWorkClientNum/K));
    edAverCorrectTime.Text :=FloatToStr(avAverCorrectTime/K);
    edAverWaitTime.Text :=FloatToStr(avAverWaitTime/K);
    edServerErrNums.Text :=IntToStr(Round(avServerErrNums/K));
    edCorrectServerTime.Text :=FloatToStr(avCorrectServerTime/K);
    edNewClientErrorAdd.Text :=IntToStr(Round(avNewClientErrorAdd/K));
    edNewServerErrorAdd.Text :=IntToStr(Round(avNewServerErrorAdd/K));
    edCurTime.Text := FloatToStr(dT*M);
    edPer.Text := FloatToStr(avPer/K);
    edTer.Text := FloatToStr(avTer/K);
    edAverTer.Text := FloatToStr(avAverTer/K);
    edKg.Text := FloatToStr(avKg/K);

    MultySeriesVal(chNums.Series[0], 1/K);
    MultySeriesVal(chClientErrors.Series[0], 1/K);
    MultySeriesVal(chErrorsGist.Series[0], 1/K);
//    MultySeriesVal(chServerErrors.Series[0], 1/K);
    MultySeriesVal(chAvTer.Series[0], 1/K);
    MultySeriesVal(chErrorsIntensity.Series[0], 1/K);

  end;//with wndPlayRes do begin

  wndAllResults.edRecallClick(nil);

end;


//   fromSer  toSer
//    
function TMonteCarloPK.AddSeriesVal(fromSer, toSer: TChartSeries): Integer;
var j: Integer;
begin
  result := 0;
  for j:=0 to (fromSer.XValues.Count-1) do begin
    if (toSer.Count-1) < j then toSer.AddXY(fromSer.XValues[j], fromSer.YValues[j], '',  clTeeColor )
    else toSer.YValues[j] := toSer.YValues[j] + fromSer.YValues[j];
    Inc(result);
  end; //for j:=0 to (destSer.XValues.Count-1) do begin
end;

//      toSer  multy
//    
function TMonteCarloPK.MultySeriesVal(toSer: TChartSeries; multy: Double): Integer;
var j: Integer;
begin
  result := 0;
  for j:=0 to (toSer.XValues.Count-1) do begin
    toSer.YValues[j] := toSer.YValues[j] * multy;
    Inc(result);
  end; //for j:=0 to (destSer.XValues.Count-1) do begin
end;



//   M  
//     
function TMonteCarloPK.PlayAllStep( callThread: TThread ): TfmPlayResults;
var i, procent: Integer;
 averCorrectTime, averWaitTime: Double;    //       
 client: TClient;
 error: TError;
 errNum, j, k: Integer;
 wndPlayRes: TfmPlayResults; //    
begin
//  result := 0;
  BeginPlay;

//     
  wndPlayRes := TfmPlayResults.Create(Application);
  result := wndPlayRes;
  wndPlayRes.Caption := '' + IntToStr(GetPlayNum) + '  ' + ' ' + DateTimeToStr(Now);
  wndPlayRes.meBeginSettings.Lines.Add( GetBeginSettingsStr);
  if Not isUpdate then wndPlayRes.WindowState := wsMinimized
  else wndPlayRes.WindowState := wsMaximized;

  procent := Round(M/100);
  if procent = 0 then procent := 1;
  for i:=0 to M do begin
//    if( callThread <> nil ) then callThread.Suspend;


    PlayIteration;
    if (busyProgrammersNum = 0) AND (serverStatus <> 1) then begin
      curTer := curTer + dT;
      Ter := curTer;
    end;
    Per :=  a* (errorClientList.Count+errorServerList.Count)*(clientsNum+1)*Yk*dT;
    if( Per > 1) then Per := 1;
//    Inc(result);

    //      
      with wndPlayRes do begin
        edCurTime.Text := FloatToStr(i*dT);
        edWorkClientNum.Text := IntToStr(workClientNum);
        edClientErrNums.Text := IntToStr(errorClientList.Count);
        edServerErrNums.Text := IntToStr(errorServerList.Count);
        edCorrectServerTime.Text := FloatToStr(waitTime);
        edNewClientErrorAdd.Text := IntToStr(clientNewErrorAdd);
        edNewServerErrorAdd.Text := IntToStr(serverNewErrorAdd);
        edTer.Text := FloatToStr(Ter);
        edAverTer.Text := FloatToStr(averTer);
        edPer.Text := FloatToStr(Per);

        chNums.SeriesList.Series[0].AddXY(i*dT, workClientNum, '',  clTeeColor );
        chClientErrors.SeriesList.Series[0].AddXY(i*dT, errorClientList.Count, '',  clTeeColor );
//        chServerErrors.SeriesList.Series[0].AddXY(i*dT, errorServerList.Count, '',  clTeeColor );
        chAvTer.SeriesList.Series[0].AddXY(i*dT, averTer, '',  clTeeColor );
//        if( clientErrorsNumByDt <> 0 )then
//        if( (errorIntensity <> 0) AND ((Round(i*dT-waitTime) mod Round(1/dT)) = 0) ) then begin
          chErrorsIntensity.SeriesList.Series[0].AddXY(i*dT, errorIntensity/((i+1-waitTime/dT)*dT), '',  clTeeColor );
//          errorIntensity := 0;
//        end;


//        chIntensity.SeriesList.Series[0].AddXY(i*dT, clientErrorsNumByDt, '',  clTeeColor );
//        chIntensity.SeriesList.Series[1].AddXY(i*dT, clientCorrectNumByDt, '',  clTeeColor );
//        if(errorIntensity <> 0) then
//          chErrorIntensity.SeriesList.Series[0].AddXY(i*dT, errorIntensity, '',  clTeeColor );


        //         1     
        if (i mod procent) = 0 then begin
          //     
          chErrorsGist.SeriesList.Series[0].Clear;
          for j:=0 to 99 do begin
            errNum := 0;
            for k:=0 to (errorClientList.Count-1) do begin
              error := errorClientList.Items[k] as TError;
              if  (100*error.GetData >= j) AND (100*error.GetData < (j+1)) then
                Inc(errNum);
            end; //for k
            chErrorsGist.SeriesList.Series[0].AddXY(j+1, errNum, '',  clTeeColor );
          end; //for j

          wndPlayRes.edKg.Text :=
             FloatToStr( (dT*(i+1)*(clientList.Count+1)-programInRepairTime{averCorrectTime-averWaitTime-waitTime})/(dT*(i+1)*(clientList.Count+1)) );

          if isUpdate then Update;
        end;

      end; //with wndPlayRes do begin

//    if( callThread <> nil ) then callThread.Resume;

  end; //for i:=0 to M do begin

  //   
  averCorrectTime := 0;
  averWaitTime := 0;
  for i:=0 to clientList.Count-1 do begin
    client := clientList.Items[i] as TClient;
    averCorrectTime := averCorrectTime + client.errorTime;
    averWaitTime := averWaitTime + client.waitTime;
  end;


  averCorrectTime := averCorrectTime/clientList.Count;
  averWaitTime := averWaitTime/clientList.Count;
  wndPlayRes.edAverCorrectTime.Text := FloatToStr(averCorrectTime);
  wndPlayRes.edAverWaitTime.Text := FloatToStr(averWaitTime);

  wndPlayRes.edKg.Text :=
      FloatToStr( (dT*M*(clientList.Count+1)-programInRepairTime{averCorrectTime-averWaitTime-waitTime})/(dT*M*(clientList.Count+1)) );

  if averTer = 0 then averTer := Ter else averTer := (averTer + Ter)/2;
  wndPlayRes.edAverTer.Text := FloatToStr(averTer);


  wndPlayRes.Update;
  isUpdate := True;

end;


//    p
//  True -  , False -  
function TMonteCarloPK.PlayEvent(p: Double): Boolean;
var e: Double;
begin
  result := False;
  e:=Random;
  if e <= p then result := true;

end;

//   
procedure TMonteCarloPK.PlayIteration;
var
 i : Integer;
 curError: TError;
 playRes: Boolean;
 client: TClient;
 curData: Double;
 newErrorNum: Integer;
 isProgrInRepair: Boolean;
begin

//  clientErrorsNumByDt := 0;
  clientCorrectNumByDt := 0;
//  errorIntensity := 0;


  if serverStatus = 1 then begin //  ,   ,     
//    errorIntensity := errorIntensity + 1 ;
    playRes := false;
    if curTer <> 0 then begin
      Ter := curTer; curTer := 0;
      if averTer = 0 then averTer := Ter else averTer := (averTer + Ter)/2;
    end;
    for i:=0 to (programmersNum-1) do begin //    programmersNum 
      playRes := PlayEvent( 1-Exp(-(Mu*dT)/coeffComplexity) );
      //      ,    
      newErrorNum := PlayErrorInsert(errorServerList);
      Inc(serverNewErrorAdd, newErrorNum);

      if playRes = True then break;

    end;
    if playRes = True then begin //  
      serverStatus := 0;
      //               
      errorServerList.Delete( errorServerList.IndexOf(error) );
      error := nil;
    end;

    waitTime := waitTime + dT;
    programInRepairTime := programInRepairTime + dT*(clientList.Count+1);
  end
  else begin // ,             
    isProgrInRepair := false;
    for i:=0 to (clientList.Count-1) do begin
      client := clientList.Items[i] as TClient;
      case client.status of
        0: begin //       c  Yk
           client.workTime := client.workTime + dT;
           playRes := PlayEvent( 1 - Exp(-Yk*dT) );
           if( playRes = True ) then begin //       
             curData := client.PlayData; //   
             //     
             client.error := GetErrorID( errorClientList, curData, (a*Random)/2 );
             if client.error <> nil then begin //  
               errorIntensity := errorIntensity + 1;;
//               Inc(clientErrorsNumByDt);
               Dec(workClientNum);
               if busyProgrammersNum < programmersNum then begin //    
                 Inc(busyProgrammersNum);
                 client.status := 1;
               end
               else begin//      
                 client.status := 2;
               end;
             end
             else begin //   
               curData := client.PlayData; //  
               //     
               curError := GetErrorID( errorServerList, curData,
                                       (a*10*Random)/2 );
               if curError <> nil then begin //  
                 serverStatus := 1;
                 error := curError;
                 errorIntensity := errorIntensity + 1;
               end;
             end; //if curErrID <> -1 then begin
           end; // if( playRes = True ) then begin;
        end;  //end case 0

        1: begin //       
           if Not isProgrInRepair then begin
             isProgrInRepair := true;
             programInRepairTime := programInRepairTime + dT;
           end;
           if curTer <> 0 then begin
             Ter := curTer; curTer := 0;
             if averTer = 0 then averTer := Ter else averTer := (averTer + Ter)/2;
           end;
           client.errorTime := client.errorTime + dT;
           playRes := PlayEvent( 1-Exp(-Mu*dT) );
           if playRes = True then begin //  
              CorrectError( client.error ); //     
            end;
           //        ,    
           newErrorNum := PlayErrorInsert(errorClientList);
           Inc(clientNewErrorAdd, newErrorNum);

        end; // case 1

        2: begin //          
          if Not isProgrInRepair then begin
            isProgrInRepair := true;
            programInRepairTime := programInRepairTime + dT;
          end;
          if curTer <> 0 then begin
            Ter := curTer; curTer := 0;
            if averTer = 0 then averTer := Ter else averTer := (averTer + Ter)/2;
           end;
           client.waitTime := client.waitTime + dT;
           if busyProgrammersNum < programmersNum then begin //          
              client.status := 1;
              Inc(busyProgrammersNum);
           end;
        end; // case 1
      end; //case
//!!      if( serverStatus <> 0 ) then break; //   -         .
    end; //for i:=0 to (clientList.Count-1) do begin
  end; //if serverStatus = 1 then begin

//  errorIntensity := errorIntensity / dT;

end;

//   ,     data +- delta
//     ,    1
function TMonteCarloPK.GetErrorID( errLst: TObjectList; data, delta: Double): TError;
var
 i:Integer;
 error: TError;
begin
 result := nil;
 for i:=0 to (errLst.Count-1) do begin
   error := errLst.Items[i] as TError;
   if( Abs( error.GetData - data ) <= delta ) then begin
     result := error;
     break;
   end;
 end;//end for
end;

//          
// errLst   p
//    
function TMonteCarloPK.PlayErrorInsert( errLst: TObjectList ): Integer ;
var
 curP: Double;
 event: Boolean;
 error: TError;
begin
 result := 0;
 if isP_newErr then begin
   curP := P_newErr;
 end
 else begin
   curP := 1 - exp(-Y_newErr*dT);
 end;

   if( curP = 0 ) then exit;
   while True do begin
     event := PlayEvent( curP );
     if event = True then begin // -          
       error := TError.Create(Random);
       errLst.Add( error );
       Inc(result);
     end
     else break;
     curP := curP * P_newErr;
   end;
end;

//    errorID      
//        
//      
function TMonteCarloPK.CorrectError( err: TError ): Integer;
var
 ii: Integer;
 clnt: TClient;
begin
  result := 0;
  for ii:=0 to (clientList.Count-1) do begin
    clnt := clientList.Items[ii] as TClient;
    if (clnt.status <> 0) AND (clnt.error = err) then begin
      Inc( result );
      if clnt.status = 1 then begin
        Dec(busyProgrammersNum);
      end;
      clnt.status := 0;
      clnt.error := nil;
      Inc(workClientNum);
      Inc(clientCorrectNumByDt);
    end;
  end;
  errorClientList.Delete(errorClientList.IndexOf(err));

end;

//  
//       

function TMonteCarloPK.BeginPlay: Integer;
var i: Integer;
    client: TClient;
    error: TError;
begin

 result := 0;
 Inc(playNum);


 Randomize;

 //    
 if clientList = Nil then clientList := TObjectList.Create
 else begin
   for i:=(clientList.Count-1) downto 0  do begin
     clientList.Delete(i);
   end;
 end;

 //  
 for i:=0 to (clientsNum-1) do begin
   client := TClient.Create(0);
   clientList.Add(client);
   Inc(result);
 end;


 //     
 if errorClientList = Nil then errorClientList := TObjectList.Create
 else begin
   for i:=(errorClientList.Count-1) downto 0  do begin
     errorClientList.Delete(i);
   end;
 end;

 //   
 for i:=0 to (errorsNum0-1) do begin
   error := TError.Create(Random);
   errorClientList.Add(error);
   Inc(result);
 end;


 //     
 if errorServerList = Nil then errorServerList := TObjectList.Create
 else begin
   for i:=(errorServerList.Count-1) downto 0  do begin
     errorServerList.Delete(i);
   end;
 end;

 //   
 for i:=0 to Round((coeffComplexity*errorsNum0)/(10{*clientsNum})) do begin
   error := TError.Create(Random);
   errorServerList.Add(error);
   Inc(result);
 end;


 waitTime := 0;
 serverStatus := 0;
 busyProgrammersNum := 0;
 workClientNum := clientsNum;
 clientNewErrorAdd := 0;
 serverNewErrorAdd := 0;
 curTer := 0; Ter := 0; averTer := 0;
 programInRepairTime := 0;
 errorIntensity := 0;

end;

//       
 function TMonteCarloPK.InitializeByFormSettings : boolean;
 var
   aRec: Double;
 begin
   playNum:=0;
   isUpdate := True;

   result := false;
   with fmSettings do begin
    try
      clientsNum := StrToInt(edClientsNum.Text);
      if clientsNum <= 0 then raise Exception.Create('   0  ');
    except
      ShowMessage(' -     ');
      ActiveControl := edClientsNum;
      exit;
    end;

    try
      programmersNum := StrToInt(edProgrammersNum.Text);
      if programmersNum <= 0 then raise Exception.Create('   0  ');
    except
      ShowMessage('      ');
      ActiveControl := edProgrammersNum;
      exit;
    end;

    try
      a := StrToFloat(edA.Text);
      if (a <= 0) OR (a >= 1) then raise Exception.Create(' , 0  >=1   ');
    except
      ShowMessage('      ');
      ActiveControl := edA;
      exit;
    end;

    try
      errorsNum0 := StrToInt(edErrorsNum0.Text);
      if errorsNum0 <= 0 then raise Exception.Create('   0  ');
    except
      ShowMessage('         ');
      ActiveControl := edErrorsNum0;
      exit;
    end;

    try
      coeffComplexity := StrToFloat(edCoeffComplexity.Text);
      if coeffComplexity <= 0 then raise Exception.Create('   0  ');
    except
      ShowMessage('      ');
      ActiveControl := edCoeffComplexity;
      exit;
    end;

    try
      Yk := StrToFloat(edYk.Text);
      if Yk <= 0 then raise Exception.Create('   0  ');
    except
      ShowMessage('          ');
      ActiveControl := edYk;
      exit;
    end;

    try
      Mu := StrToFloat(edMu.Text);
      if Mu <= 0 then raise Exception.Create('   0  ');
    except
      ShowMessage('         ');
      ActiveControl := edMu;
      exit;
    end;

    isP_newErr := rbP.Checked;
    if isP_newErr then begin
      try
        P_newErr := StrToFloat(edP_newErr.Text);
        if (P_newErr < 0) Or (P_newErr >= 1) then raise Exception.Create('   >= 1  ');
      except
        ShowMessage('            < 1');
        ActiveControl := edP_newErr;
        exit;
      end;
    end
    else begin
      try
        Y_newErr := StrToFloat(edY_newErr.Text);
        if (Y_newErr < 0) then raise Exception.Create('   ');
      except
        ShowMessage('             < 1');
        ActiveControl := edY_newErr;
        exit;
      end;
    end;

    try
      dT := StrToFloat(edDT.Text);
      if (dT <= 0) then begin
        raise Exception.Create('   ');
      end;
    except
      ShowMessage('      ');
      ActiveControl := edDT;
      exit;
    end;

    try
      M := StrToInt(edM.Text);
      if M <= 0 then raise Exception.Create('   0  ');
    except
      ShowMessage('      ');
      ActiveControl := edM;
      exit;
    end;

    try
      K := StrToInt(edK.Text);
      if K <= 0 then raise Exception.Create('   0  ');
    except
      ShowMessage('      ');
      ActiveControl := edK;
      exit;
    end;


    //        dt 
    //    
    if (dT * Yk - 1.009) > 0  then begin
      dT := 1/Yk;
      edDT.Text := FloatToStr(dT);
//      M := Round(M * Yk);
//      edM.Text := IntToStr(M);
      ShowMessage('    ,            < 1.            ' + edDT.Text);
     end;

    //     dt 
    //    
    if (dT * Mu - 1.009) > 0  then begin
      dT := 1/Mu;
      edDT.Text := FloatToStr(dT);
//      M := Round(M * Yk);
//      edM.Text := IntToStr(M);
      ShowMessage('    ,         < 1.          ' + edDT.Text);
     end;

    //        
    if (a * Yk - 0.1009) > 0  then begin
      aRec := 0.1/Yk;
//      edA.Text := FloatToStr(a);
      ShowMessage('            << 1.                ' + FloatToStr(aRec));
     end;


    buAllTimeClick(nil);

   end; //with
  result := true;
 end;

//        
//   p,    y0  ,   t
//        
 function TMonteCarloPK.SearchFirstErrorsNum( p: Double; y0: Double; t: Double) : Integer;
  var
    curF, f: Double;
    isMultiply, isBig: Boolean;
    g1, g2: Integer;
 begin
   result := 1000;
   f := Ln(p);
   isMultiply := True;
   g1:=0; g2:=result;

   curF := CallKoeff(y0*t, result);
//   curF2 := CallKoeff(y0*t, result+10);
   if( Abs(curF-f) < 0.0001 ) then exit;

   if( curF > f ) then isBig:=false else isBig := true;


   while true  do begin
     if isMultiply then begin
       if isBig then begin
         g2 := result;
         result := Round(result/10);
         g1 := result;
       end
       else begin
         g1:=result;
         result := result*10;
         g2:=result;
       end;
     end
     else begin
       result := Round((g1+g2)/2);
     end;

     if Abs(g1-g2) <= 1 then exit;
     curF := CallKoeff(y0*t, result);

     if isMultiply then  begin
       if((curF>f) <> isBig ) then isMultiply := false;
     end
     else
     if curF < f then begin
       g2 := result;
     end
     else begin
       g1:=result;
     end;



   end; //while

 end;

 //      a  E  a**E/E!
 function TMonteCarloPK.CallKoeff( a: Double; E: Integer) : Double;
 var i:Integer;
 begin
   result := E*Ln(a)- a;
   for i:=2 to E do begin
     result := result - Ln(i);
   end;
 end;

 //   k    t   y
 function TMonteCarloPK.P( y, t: Double; k: Integer) : Double;
 var i:Integer;
 begin
   result := 1;
   for i:=1 to k do begin
     result := result *(y*t)/i;
   end;
   result := result*Exp(-y*t);

 end;

 function TMonteCarloPK.GetPlayNum: Integer;
 begin
   result := playNum;
 end;

 //      
 function TMonteCarloPK.GetBeginSettingsStr: String;
 begin
   result := '- -: ' + IntToStr(clientsNum) +
   ', - : ' + IntToStr(programmersNum) +
   ',      ()    : ' + FloatToStr(a) +
   ',  - : ' + IntToStr(errorsNum0) +
   ',   : ' + FloatToStr(coeffComplexity) +
   ',      : ' + FloatToStr(Yk) + ' (1/)' +
   ',    : ' + FloatToStr(Mu) + ' (1/)';
   if isP_newErr then
     result := result + ',     : ' + FloatToStr(P_newErr)
   else
     result := result + ',     : ' + FloatToStr(Y_newErr) + ' (1/)';

   result := result +
   ',  : ' + FloatToStr(dT) +
   ', - : ' + IntToStr(M) +
   ',   : ' + fmSettings.edTime.Text  + ' ()';



 end;

end.
